<?php
/*
**Function to create the database
*/
 function DBCreate($ScoreDir)
      {
       if (!($NamenDB = fopen($ScoreDir."Namen.csv", "w")))
         {
          return(False);
          exit;
         };
       fputs($NamenDB, "NameNr,Name,IdNummer,Quiz\r\n", 127);
       fclose($NamenDB);
       $DatDB = fopen($ScoreDir."Dat.csv", "w");
       fputs($DatDB, "DatNr,NameNr,Datum,Score,Zeit,A,F,fertig\r\n", 127);
       fclose($DatDB);
       $SpielStandDB = fopen($ScoreDir."SplStand.csv", "w");
       fputs($SpielStandDB, "SpielStandNr,DatNr,FrageNo,FrZeit,falsch,notsolved\r\n", 127);
       fclose($SpielStandDB);
       return(True);
      };

/*
**Function to update the files "$Dat.csv" and "SplStand.csv"
*/
 function DBUpdate($ScoreDir, $SpielStandLine, $DatLine)
      {
       global  $ErrorText1;
       $SpielStandDB = fopen($ScoreDir."SplStand.csv", "r+");
       if (!(flock($SpielStandDB, 2)))                                               //Lock SpielStandDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($SpielStandDB);
          exit;
         };
       $I = 0;
       while ($SpStLine = fgetcsv($SpielStandDB, 128, ","))
             {
              $SpielStandArray[$I] = $SpStLine;
              $I++;
             };
       fclose($SpielStandDB);
       $SpielStandDB = fopen($ScoreDir."SplStand.csv", "w");
       for ($I=0; $I<count($SpielStandArray); $I++)
          {
           if ($SpielStandArray[$I][0] != $SpielStandLine[0])
                {
                 fputs($SpielStandDB, implode(",", $SpielStandArray[$I])."\r\n", 127);
                }
               else
                {
                 fputs($SpielStandDB, implode(",", $SpielStandLine)."\r\n", 127);
                };
           };
       flock($SpielStandDB, 3);
       fclose($SpielStandDB);
    //Update data for DatDB
       if ($SpielStandLine[5] == 0)
          {
           $DatLine[4] = $DatLine[4] + $SpielStandLine[3];
           $DatLine[5] = $DatLine[5] + 1;
           if ($SpielStandLine[4] == 1)
              {
               $DatLine[6] = $DatLine[6] + 1;
              };
          };
    //Update DatDB
       $DatDB = fopen($ScoreDir."Dat.csv", "r+");
       if (!(flock($DatDB, 2)))                                          //Lock DatDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($DatDB);
          exit;
         };
       $I = 0;
       while ($DLine = fgetcsv($DatDB, 128, ","))
             {
              $DatArray[$I] = $DLine;
              $I++;
             };
       fclose($DatDB);
       $DatDB = fopen($ScoreDir."Dat.csv", "w");
       for ($I=0; $I<count($DatArray); $I++)
          {
           if ($DatArray[$I][0] != $DatLine[0])
                {
                 fputs($DatDB, implode(",", $DatArray[$I])."\r\n", 127);
                }
               else
                {
                 fputs($DatDB, implode(",", $DatLine)."\r\n", 127);
                };
           };
       flock($DatDB, 3);
       fclose($DatDB);
       return(True);
      };


/*
**Function to update the file "$Dat.csv" only
*/
 function DatUpdate($ScoreDir, $DatLine)
      {
       global  $ErrorText1;
    //Update DatDB
       $DatDB = fopen($ScoreDir."Dat.csv", "r+");
       if (!(flock($DatDB, 2)))                                          //Lock DatDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($DatDB);
          exit;
         };
       $I = 0;
       while ($DLine = fgetcsv($DatDB, 128, ","))
             {
              $DatArray[$I] = $DLine;
              $I++;
             };
       fclose($DatDB);
       $DatDB = fopen($ScoreDir."Dat.csv", "w");
       for ($I=0; $I<count($DatArray); $I++)
          {
           if ($DatArray[$I][0] != $DatLine[0])
                {
                 fputs($DatDB, implode(",", $DatArray[$I])."\r\n", 127);
                }
               else
                {
                 fputs($DatDB, implode(",", $DatLine)."\r\n", 127);
                };
           };
       flock($DatDB, 3);
       fclose($DatDB);
       return(True);
      };


/*
**Function to delete certain records of the files "Dat.csv" and "SplStand.csv"
*/
 function RecordsDelete($ScoreDir, $age, $incomplete)
      {
       global  $ErrorText1;
    //Screen DatDB and delete some records
       if (!($DatDB = fopen($ScoreDir."Dat.csv", "r+")))
         {
          return(False);
          exit;
         };
       if (!(flock($DatDB, 2)))                                          //Lock DatDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($DatDB);
          exit;
         };
       $I = 0;
       while ($DLine = fgetcsv($DatDB, 128, ","))
             {
              $DatArray[$I] = $DLine;
              $I++;
             };
       fclose($DatDB);
       $J = 0;
       $DatNrToDelete = array();
       $DatDB = fopen($ScoreDir."Dat.csv", "w");
       fputs($DatDB, implode(",", $DatArray[0])."\r\n", 127);
       for ($I=1; $I<count($DatArray); $I++)
          {
           if (((time() - strtotime($DatArray[$I][2])) <= $age)
               or (($incomplete) and ($DatArray[$I][7])))
             {
              fputs($DatDB, implode(",", $DatArray[$I])."\r\n", 127);
             }
            else
             {
               //store all removed DatNr's to delete the respective SpielStand records
              $DatNrToDelete[$J] = $DatArray[$I][0];
              $J++;
             };
          };
       flock($DatDB, 3);
       fclose($DatDB);
       if (!($SpielStandDB = fopen($ScoreDir."SplStand.csv", "r+")))
         {
          return(False);
          exit;
         };
       if (!(flock($SpielStandDB, 2)))                                               //Lock SpielStandDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($SpielStandDB);
          exit;
         };
       $I = 0;
       while ($SpStLine = fgetcsv($SpielStandDB, 128, ","))
             {
              $SpielStandArray[$I] = $SpStLine;
              $I++;
             };
       fclose($SpielStandDB);
         //Write SplStand.csv
       $SpielStandDB = fopen($ScoreDir."SplStand.csv", "w");
       fputs($SpielStandDB, implode(",", $SpielStandArray[0])."\r\n", 127);
       for ($I=1; $I<count($SpielStandArray); $I++)
          {
           if (! (in_array($SpielStandArray[$I][1], $DatNrToDelete)))
                {
                 fputs($SpielStandDB, implode(",", $SpielStandArray[$I])."\r\n", 127);
                };
           };
       flock($SpielStandDB, 3);
       fclose($SpielStandDB);
       return(True);
      };

/*
**Function to delete orphan records of the file "Namen.csv"
*/
 function NamenRecordsDelete($ScoreDir)
      {
       global  $ErrorText1;
         //Get Namen table
       if (!($NamenDB = fopen($ScoreDir."Namen.csv", "r+")))
         {
          return(False);
          exit;
         };
       if (!(flock($NamenDB, 2)))                                          //Lock NamenDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($NamenDB);
          exit;
         };
       $I = 0;
       while ($NamenLine = fgetcsv($NamenDB, 256, ","))
             {
              $NamenArray[$I] = $NamenLine;
              $I++;
             };
       fclose($NamenDB);
         //Get all NameNr in Dat.csv
       $DatDB = fopen($ScoreDir."Dat.csv", "r+");
       if (!(flock($DatDB, 2)))                                          //Lock DatDB
         {
          $ErrorText = $ErrorText1;
          $NamenDB = fopen($ScoreDir."Namen.csv", "r+");
          flock($NamenDB, 3);
          fclose($NamenDB);
          include("error.php");
          fclose($DatDB);
          exit;
         };
       $I = 0;
       while ($DLine = fgetcsv($DatDB, 128, ","))
             {
              $NameNrArray[$I] = $DLine[1];
              $I++;
             };
       flock($DatDB, 3);
       fclose($DatDB);
         //Write Namen.csv
       $NamenDB = fopen($ScoreDir."Namen.csv", "w");
       fputs($NamenDB, implode(",", $NamenArray[0])."\r\n", 255);
       for ($I=1; $I<count($NamenArray); $I++)
          {
           if (in_array($NamenArray[$I][0], $NameNrArray))
                {
                 fputs($NamenDB, implode(",", $NamenArray[$I])."\r\n", 255);
                };
           };
       flock($NamenDB, 3);
       fclose($NamenDB);
       return(True);
      };
?>