<?php
 /*
 ** Description: Checks for password and deletes records in database.
 */
   //Reference to functions needed
 include("DTXdatabaseFunctions.php");
 include("locals.php");


/*
**Function to delete all records belonging to $ManName
*/
 function NamenDelete($ScoreDir, $ManName)
      {
       global  $ErrorText1;
         //Get Namen table
       ignore_user_abort(true);
       if (!($NamenDB = fopen($ScoreDir."Namen.csv", "r+")))
         {
          return(False);
          ignore_user_abort(false);
          exit;
         };
       if (!(flock($NamenDB, 2)))                                          //Lock NamenDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($NamenDB);
          ignore_user_abort(false);
          exit;
         };
       $I = 0;
       $J = 0;
       $NameNrToDelete = array();
       while ($NamenLine = fgetcsv($NamenDB, 256, ","))
             {
              if (!($NamenLine[1] == $ManName))
                {
                 $NamenArray[$I] = $NamenLine;
                 $I++;
                }
               else
                {
                  //store all removed NameNr's to delete the respective Dat records
                 $NameNrToDelete[$J] = $NamenLine[0];
                 $J++;
                };
             };
       fclose($NamenDB);
         //Write Namen.csv
       $NamenDB = fopen($ScoreDir."Namen.csv", "w");
       fputs($NamenDB, implode(",", $NamenArray[0])."\r\n", 255);
       for ($I=1; $I<count($NamenArray); $I++)
          {
           fputs($NamenDB, implode(",", $NamenArray[$I])."\r\n", 255);
          };
       flock($NamenDB, 3);
       fclose($NamenDB);

       if (!($DatDB = fopen($ScoreDir."Dat.csv", "r+")))
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          ignore_user_abort(false);
          exit;
         };
       if (!(flock($DatDB, 2)))                                          //Lock DatDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($DatDB);
          ignore_user_abort(false);
          exit;
         };
       $I = 0;
       while ($DLine = fgetcsv($DatDB, 128, ","))
             {
              $DatArray[$I] = $DLine;
              $I++;
             };
       fclose($DatDB);
       $J = 0;
       $DatNrToDelete = array();
       $DatDB = fopen($ScoreDir."Dat.csv", "w");
       for ($I=0; $I<count($DatArray); $I++)
          {
           if (! (in_array($DatArray[$I][1], $NameNrToDelete)))
                {
                 fputs($DatDB, implode(",", $DatArray[$I])."\r\n", 127);
                }
               else
                {
                 $DatNrToDelete[$J] = $DatArray[$I][0];
                 $J++;
                };
           };
       flock($DatDB, 3);
       fclose($DatDB);

       if (!($SpielStandDB = fopen($ScoreDir."SplStand.csv", "r+")))
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          ignore_user_abort(false);
          exit;
         };
       if (!(flock($SpielStandDB, 2)))                                               //Lock SpielStandDB
         {
          $ErrorText = $ErrorText1;
          include("error.php");
          fclose($SpielStandDB);
          ignore_user_abort(false);
          exit;
         };
       $I = 0;
       while ($SpStLine = fgetcsv($SpielStandDB, 128, ","))
             {
              $SpielStandArray[$I] = $SpStLine;
              $I++;
             };
       fclose($SpielStandDB);
         //Write SplStand.csv
       $SpielStandDB = fopen($ScoreDir."SplStand.csv", "w");
       fputs($SpielStandDB, implode(",", $SpielStandArray[0])."\r\n", 127);
       for ($I=1; $I<count($SpielStandArray); $I++)
          {
           if (! (in_array($SpielStandArray[$I][1], $DatNrToDelete)))
                {
                 fputs($SpielStandDB, implode(",", $SpielStandArray[$I])."\r\n", 127);
                };
           };
       flock($SpielStandDB, 3);
       fclose($SpielStandDB);
       ignore_user_abort(false);
       return(True);
      };

//Begin
   //Text, which is often used
 $ErrorText1 = 'Database is busy.<br> "Reload" to try again now, or try later!';

    //check password
 if ((($_POST["days"] != "") or ($_POST["Name"] != "")) and ($_POST["pw"] != $password))
   {
    $ErrorText = 'Password is wrong. <br> Permission to edit database denied!';
    include("error.php");
    exit;
   };
 if ($_POST["days"] != "")
   {
    if (!(($_POST["days"] * 1) > 0))
      {
       $ErrorText = 'Please insert a number greater 0 as number of days!';
       include("error.php");
       exit;
      };
      //delete records in Dat.csv and SplStand.csv
    if (RecordsDelete($ScoreDirectory, ($_POST["days"] * 86400), $_POST["unfinished"]))
      {
       $resulttext = '<b>Database was successfully modified.</b><br>';
      }
     else
      {
       $ErrorText = 'Could not delete any records. Database may be busy.<br> "Reload" to try again now, or try later!';
       include("error.php");
       exit;
      };
    if (NamenRecordsDelete($ScoreDirectory))  //delete orphan records in Namen.csv
      {
       $resulttext = '<b>Database was successfully modified.</b><br>';
      }
     else
      {
       $ErrorText = 'Could not delete any records. Database may be busy.<br> "Reload" to try again now, or try later!';
       include("error.php");
       exit;
      };
   };
 if ($_POST["Name"] != "")
   {
    if (NamenDelete($ScoreDirectory, $_POST["Name"]))  //delete all records belonging to "Name"
      {
       $resulttext = '<b>Database was successfully modified.</b><br>';
      }
     else
      {
       $ErrorText = 'Could not delete any records. Database may be busy.<br> "Reload" to try again now, or try later!';
       include("error.php");
       exit;
      };
   };
?>
<!DOCTYPE HTML PUBLIC "-//w3c//dtd html 4.0 transitional//en">
<HTML>
<HEAD>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <META NAME="Author" CONTENT="Schneider Luzius">
   <meta name="GENERATOR" content="PHPWebQuiz 1.4.0 [(C) 2001 - 2008 by Luzius Schneider] http://www.luziusschneider.com">
   <TITLE>Edit LS PHPWebQuiz's training record</TITLE>
   <link rel="stylesheet" type="text/css" href="PHPWebQuiz.css">
</HEAD>
<BODY>
<TABLE WIDTH="100%">
<TR>
<TD WIDTH="15%"></TD>
<TD><H2><IMG SRC="PHPWQ.gif" ALT=" " NOSAVE height=32 width=100 align=left hspace=20>Edit PHPWebQuiz's training record</H2></TD>
</TR>
</TABLE>
<?php  //insert success message
 if ($resulttext != '')
   {
    print('<br><hr><br>');
    print($resulttext);
    print('<br><hr><br>');
   };
?>
<FORM NAME="EDForm" METHOD="POST" ACTION="editdatabase.php">
<TABLE WIDTH="100%">
<TR>
<TD WIDTH="15%">Insert password:</TD>
<TD><INPUT TYPE="PASSWORD" NAME="pw" SIZE="40" TITLE="Insert password!"></TD>
</TR>
</TABLE>
<hr width="50%" align="left">
Delete all data, which is older then
<INPUT TYPE="TEXT" NAME="days" SIZE="10" Title="Please insert a number greater 0!">
days!
<BLOCKQUOTE><INPUT TYPE="CHECKBOX" NAME="unfinished">
But only for unfinished quiz!</BLOCKQUOTE>
<hr width="30%" align="left">
<BLOCKQUOTE><B>OR</B>
<BR>
Delete all data, belonging to</BLOCKQUOTE>
<TABLE WIDTH="100%">
<TR>
<TD WIDTH="15%">Your name:</TD>
<TD><INPUT TYPE="TEXT" NAME="Name" SIZE="50"></TD>
</TR>
</TABLE>
<hr width="50%" align="left">
<br>
<blockquote>
<table cellspacing="5">
<tr><td><A HREF="admin.php" title="Access results table">PHPWebQuiz Administration</A></td>
<td width="60%" ALIGN="center"><INPUT TYPE="SUBMIT" NAME="Start" VALUE="   START   "></td></tr>
</table>
</blockquote>
</FORM>
<hr>
<br>
<div align=right><b><font size=-1>LS PHPWebQuiz 1.4.0</font></b>
<br><font size=-1><a href="http://www.luziusschneider.com" TARGET="_blank">http://www.luziusschneider.com</a></font></div>
</BODY>
</HTML>